﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.Remoting;
using System.Runtime.Remoting.Channels;
using System.Runtime.Remoting.Channels.Tcp;
using System.Runtime.Serialization.Formatters.Binary;

using RemotingLibrary;

namespace RemotingClient
{
	//
	// 닷넷 리모팅 인스턴스 관리 테스트용 클라이언트
	//
	class RemotingClient
	{
		static void Main(string[] args)
		{
			Console.WriteLine(".NET Remoting Test Client...");

			RemotingConfiguration.RegisterWellKnownClientType(
				typeof(SingleCallObject),
				"tcp://localhost:8082/SingleCallObject.rem");
			RemotingConfiguration.RegisterWellKnownClientType(
				typeof(SingletonObject),
				"tcp://localhost:8082/SingletonObject.rem");
			RemotingConfiguration.RegisterActivatedClientType(
				typeof(ClientActivatedObject),
				"tcp://localhost:8082");

			SingleCallObject obj = new SingleCallObject();
			Console.WriteLine(obj.Echo("Hello SingleCallObject..."));
			Console.WriteLine(obj.Echo("Hello SingleCallObject Again..."));

			SingletonObject obj2 = new SingletonObject();
			Console.WriteLine(obj2.Echo("Hello SingletonObject..."));
			Console.WriteLine(obj2.Echo("Hello SingletonObject Again..."));

			ClientActivatedObject obj3 = new ClientActivatedObject();
			Console.WriteLine(obj3.Echo("Hello ClientActivatedObject..."));
			Console.WriteLine(obj3.Echo("Hello ClientActivatedObject Again..."));
			//obj3.Dispose();
		}
	}
}
