using System;
using System.Collections.Generic;
using System.Text;
using System.ServiceModel;

namespace WCFService
{
	[ServiceBehavior(InstanceContextMode = InstanceContextMode.PerSession)]
	public class PerSessionService : IEchoService, IDisposable
	{
		private int _CallCount = 0;

		public PerSessionService()
		{
			Console.WriteLine("PerSessionService Created...");
		}

		public void Dispose()
		{
			Console.WriteLine("PerSessionService Disposing...");
		}

		public string Echo(string msg)
		{
			_CallCount++;
			Console.WriteLine("PerSessionService::Echo() invoked... call count = {0}", 
				_CallCount);
			return "You send : " + msg;
		}
	}
}
