using System;
using System.Collections.Generic;
using System.Text;
using System.ServiceModel;

namespace WCFService
{
	[ServiceBehavior(InstanceContextMode = InstanceContextMode.Single)]
	public class SingleService : IEchoService, IDisposable
	{
		private int _CallCount = 0;

		public SingleService(int baseValue)
		{
			_CallCount = baseValue;
			Console.WriteLine("SingleService Created...");
		}

		public void Dispose()
		{
			Console.WriteLine("SingleService Disposing...");
		}

		public string Echo(string msg)
		{
			_CallCount++;
			Console.WriteLine("SingleService::Echo() invoked... call count = {0}",
				_CallCount);
			return "You send : " + msg;
		}
	}
}
